#!/usr/local/bin/perl
# delete_domain.cgi
# Delete a domain, after asking first

require './virtual-server-lib.pl';
&require_apache();
&require_bind();
&require_useradmin();
&require_mail();
&ReadParse();
$d = &get_domain($in{'dom'});
$d && $d->{'uid'} && $d->{'gid'} || &error("Domain $in{'dom'} does not exist!");
$access{'edit'} && &can_edit_domain($d) || &error($text{'edit_ecannot'});

&header($text{'delete_title'}, "");
print "<hr>\n";

@users = &list_domain_users($d, 1);
@aliases = &list_domain_aliases($d);
if (!$in{'confirm'}) {
	# Ask the user if he is sure
	print &check_clicks_function();
	$sz = &disk_usage_kb($d->{'home'});
	print "<p>",&text('delete_rusure', "<tt>$d->{'dom'}</tt>",
		  $sz, scalar(@users), scalar(@aliases)),"<p>\n";
	print "<center><form action=delete_domain.cgi>\n";
	print "<input type=hidden name=dom value='$in{'dom'}'>\n";
	print "<input type=submit name=confirm ",
	      "value='$text{'delete_ok'}' onClick='check_clicks(form)'>\n";
	print "<p><input type=checkbox name=only value=1> ",
	      "$text{'delete_only'}<br>\n";
	print "</form></center>\n";

	print "<hr>\n";
	&footer("edit_domain.cgi?dom=$in{'dom'}", $text{'edit_return'},
		"", $text{'index_return'});
	}
else {
	# Go ahead and delete ..

	# Run the before command
	&set_domain_envs($d, "DELETE_DOMAIN");
	$merr = &making_changes();
	&error(&text('delete_emaking', "<tt>$merr</tt>")) if (defined($merr));

	# Delete domain file
	print $text{'delete_domain'},"<br>\n";
	&delete_domain($d);
	print $text{'setup_done'},"<p>\n";

	if (!$in{'only'}) {
		if ($d->{'webalizer'} && $config{'webalizer'}) {
			# Delete Webalizer config
			&delete_webalizer($d);
			}

		if ($d->{'web'} && $config{'web'}) {
			# Delete from apache
			&delete_apache($d);
			&restart_apache();
			}

		if ($d->{'dns'} && $config{'dns'}) {
			# Delete from bind
			&delete_bind($d);
			&restart_bind($d);
			}

		if ($d->{'mysql'} && $config{'mysql'}) {
			# Delete from mysql
			&delete_mysql($d);
			}

		if ($d->{'postgres'} && $config{'postgres'}) {
			# Delete from postgresql
			&delete_postgres($d);
			}
		}

	if ($d->{'webmin'}) {
		# Delete from webmin
		&delete_webmin($d);
		&restart_webmin();
		}

	if (!$in{'only'}) {
		if (@users) {
			# Delete mail users and their mail files
			print $text{'delete_users'},"<br>\n";
			foreach $u (@users) {
				&delete_user($u);
				&delete_mail_file($u);
				system("rm -rf '$u->{'home'}'")
					if (-d $u->{'home'} &&
					    $u->{'home'} ne "/");
				}
			print $text{'setup_done'},"<p>\n";
			}

		# Delete all virtusers
		if (@users || @aliases) {
			print $text{'delete_aliases'},"<br>\n";
			foreach $v (&list_virtusers()) {
				if ($v->{'from'} =~ /\@(\S+)$/ &&
				    $1 eq $d->{'dom'}) {
					&delete_virtuser($v);
					}
				}
			print $text{'setup_done'},"<p>\n";
			}

		if ($d->{'mail'} && $config{'mail'}) {
			# Delete mail domain
			&delete_mail($d);
			}

		# Take down IP
		if ($d->{'iface'}) {
			print $text{'delete_virt'},"<br>\n";
			&foreign_require("net", "net-lib.pl");
			local ($biface) =
			    grep { $_->{'fullname'} eq $d->{'iface'} }
				 &net::boot_interfaces();
			local ($aiface) =
			    grep { $_->{'fullname'} eq $d->{'iface'} }
				 &net::active_interfaces();
			if ($biface->{'virtual'} ne '') {
				&net::delete_interface($biface) if ($biface);
				&net::deactivate_interface($aiface) if($aiface);
				print $text{'setup_done'},"<p>\n";
				}
			else {
				print &text('delete_novirt',
					    $d->{'iface'}),"<p>\n";
				}
			}

		# Delete unix user
		local @allusers = &useradmin::list_users();
		local ($uinfo) = grep { $_->{'user'} eq $d->{'user'}}
				      @allusers;
		if ($uinfo) {
			print $text{'delete_user'},"<br>\n";
			&delete_user($uinfo);
			print $text{'setup_done'},"<p>\n";
			}

		# Delete unix group
		local @allgroups = &useradmin::list_groups();
		local ($ginfo) =
			grep { $_->{'group'} eq $d->{'group'} } @allgroups;
		if ($ginfo) {
			print $text{'delete_group'},"<br>\n";
			&useradmin::set_group_envs($ginfo, 'DELETE_GROUP');
			&useradmin::making_changes();
			&useradmin::delete_group($ginfo);
			&useradmin::made_changes();
			print $text{'setup_done'},"<p>\n";
			}

		# Delete homedir
		if ($uinfo && -d $uinfo->{'home'} && $uinfo->{'home'} ne "/") {
			print $text{'delete_home'},"<br>\n";
			system("rm -rf '$uinfo->{'home'}'");
			print $text{'setup_done'},"<p>\n";
			}
		}

	# Run the after command
	&made_changes();

	print "<hr>\n";
	&footer("", $text{'index_return'});
	}

